/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002-2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */


/* First part of user declarations.  */

/* Line 310 of lalr1.cc  */
#line 46 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"


#include <string>
#include "iked.h"
#include "conf.parse.hpp"



/* Line 310 of lalr1.cc  */
#line 48 "conf.parse.cpp"


#include "conf.parse.hpp"

/* User implementation prologue.  */

/* Line 316 of lalr1.cc  */
#line 68 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"


#define YY_DECL                                     \
    yy::conf_parser::token_type                     \
    yylex( yy::conf_parser::semantic_type * yylval, \
    yy::conf_parser::location_type * yylloc,        \
    IKED & iked )

YY_DECL;

IDB_PEER *		peer;
IKE_PROPOSAL		proposal;
IDB_LIST_PH2ID *	idlist;



/* Line 316 of lalr1.cc  */
#line 74 "conf.parse.cpp"

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* Enable debugging if requested.  */
#if YYDEBUG

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)	\
do {							\
  if (yydebug_)						\
    {							\
      *yycdebug_ << Title << ' ';			\
      yy_symbol_print_ ((Type), (Value), (Location));	\
      *yycdebug_ << std::endl;				\
    }							\
} while (false)

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug_)				\
    yy_reduce_print_ (Rule);		\
} while (false)

# define YY_STACK_PRINT()		\
do {					\
  if (yydebug_)				\
    yystack_print_ ();			\
} while (false)

#else /* !YYDEBUG */

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_REDUCE_PRINT(Rule)
# define YY_STACK_PRINT()

#endif /* !YYDEBUG */

#define yyerrok		(yyerrstatus_ = 0)
#define yyclearin	(yychar = yyempty_)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace yy {

/* Line 379 of lalr1.cc  */
#line 140 "conf.parse.cpp"
#if YYERROR_VERBOSE

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  conf_parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              /* Fall through.  */
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

#endif

  /// Build a parser object.
  conf_parser::conf_parser (IKED & iked_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      iked (iked_yyarg)
  {
  }

  conf_parser::~conf_parser ()
  {
  }

#if YYDEBUG
  /*--------------------------------.
  | Print this symbol on YYOUTPUT.  |
  `--------------------------------*/

  inline void
  conf_parser::yy_symbol_value_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yyvaluep);
    switch (yytype)
      {
         default:
	  break;
      }
  }


  void
  conf_parser::yy_symbol_print_ (int yytype,
			   const semantic_type* yyvaluep, const location_type* yylocationp)
  {
    *yycdebug_ << (yytype < yyntokens_ ? "token" : "nterm")
	       << ' ' << yytname_[yytype] << " ("
	       << *yylocationp << ": ";
    yy_symbol_value_print_ (yytype, yyvaluep, yylocationp);
    *yycdebug_ << ')';
  }
#endif

  void
  conf_parser::yydestruct_ (const char* yymsg,
			   int yytype, semantic_type* yyvaluep, location_type* yylocationp)
  {
    YYUSE (yylocationp);
    YYUSE (yymsg);
    YYUSE (yyvaluep);

    YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

    switch (yytype)
      {
        case 125: /* "\"quoted value\"" */

/* Line 479 of lalr1.cc  */
#line 227 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
	{ delete (yyvaluep->bval); };

/* Line 479 of lalr1.cc  */
#line 247 "conf.parse.cpp"
	break;
      case 126: /* "\"label value\"" */

/* Line 479 of lalr1.cc  */
#line 228 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
	{ delete (yyvaluep->bval); };

/* Line 479 of lalr1.cc  */
#line 256 "conf.parse.cpp"
	break;
      case 127: /* "\"address value\"" */

/* Line 479 of lalr1.cc  */
#line 229 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
	{ delete (yyvaluep->bval); };

/* Line 479 of lalr1.cc  */
#line 265 "conf.parse.cpp"
	break;
      case 128: /* "\"network value\"" */

/* Line 479 of lalr1.cc  */
#line 230 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
	{ delete (yyvaluep->bval); };

/* Line 479 of lalr1.cc  */
#line 274 "conf.parse.cpp"
	break;

	default:
	  break;
      }
  }

  void
  conf_parser::yypop_ (unsigned int n)
  {
    yystate_stack_.pop (n);
    yysemantic_stack_.pop (n);
    yylocation_stack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  conf_parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  conf_parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  conf_parser::debug_level_type
  conf_parser::debug_level () const
  {
    return yydebug_;
  }

  void
  conf_parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif

  int
  conf_parser::parse ()
  {
    /// Lookahead and lookahead in internal form.
    int yychar = yyempty_;
    int yytoken = 0;

    /* State.  */
    int yyn;
    int yylen = 0;
    int yystate = 0;

    /* Error handling.  */
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// Semantic value of the lookahead.
    semantic_type yylval;
    /// Location of the lookahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location_type yyerror_range[2];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

    int yyresult;

    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stacks.  The initial state will be pushed in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystate_stack_ = state_stack_type (0);
    yysemantic_stack_ = semantic_stack_type (0);
    yylocation_stack_ = location_stack_type (0);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* New state.  */
  yynewstate:
    yystate_stack_.push (yystate);
    YYCDEBUG << "Entering state " << yystate << std::endl;

    /* Accept?  */
    if (yystate == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    /* Backup.  */
  yybackup:

    /* Try to take a decision without lookahead.  */
    yyn = yypact_[yystate];
    if (yyn == yypact_ninf_)
      goto yydefault;

    /* Read a lookahead token.  */
    if (yychar == yyempty_)
      {
	YYCDEBUG << "Reading a token: ";
	yychar = yylex (&yylval, &yylloc, iked);
      }


    /* Convert token to internal form.  */
    if (yychar <= yyeof_)
      {
	yychar = yytoken = yyeof_;
	YYCDEBUG << "Now at end of input." << std::endl;
      }
    else
      {
	yytoken = yytranslate_ (yychar);
	YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
      }

    /* If the proper action on seeing token YYTOKEN is to reduce or to
       detect an error, take that action.  */
    yyn += yytoken;
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
      goto yydefault;

    /* Reduce or error.  */
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
	if (yyn == 0 || yyn == yytable_ninf_)
	goto yyerrlab;
	yyn = -yyn;
	goto yyreduce;
      }

    /* Shift the lookahead token.  */
    YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

    /* Discard the token being shifted.  */
    yychar = yyempty_;

    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yylloc);

    /* Count tokens shifted since error; after three, turn off error
       status.  */
    if (yyerrstatus_)
      --yyerrstatus_;

    yystate = yyn;
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystate];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    /* If YYLEN is nonzero, implement the default value of the action:
       `$$ = $1'.  Otherwise, use the top of the stack.

       Otherwise, the following line sets YYVAL to garbage.
       This behavior is undocumented and Bison
       users should not rely upon it.  */
    if (yylen)
      yyval = yysemantic_stack_[yylen - 1];
    else
      yyval = yysemantic_stack_[0];

    {
      slice<location_type, location_stack_type> slice (yylocation_stack_, yylen);
      YYLLOC_DEFAULT (yyloc, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 12:

/* Line 677 of lalr1.cc  */
#line 265 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		IKE_SADDR saddr;
		memset( &saddr, 0, sizeof( saddr ) );
		saddr.saddr4.sin_family = AF_INET;
		SET_SALEN( &saddr.saddr4, sizeof( sockaddr_in ) ); 
		saddr.saddr4.sin_port = htons( (yysemantic_stack_[(3) - (3)].ival) );

		if( iked.socket_create( saddr, false ) != LIBIKE_OK )
			error( (yyloc), std::string( "daemon network configuration failed\n" ) );
	}
    break;

  case 14:

/* Line 677 of lalr1.cc  */
#line 277 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		IKE_SADDR saddr;
		memset( &saddr, 0, sizeof( saddr ) );
		SET_SALEN( &saddr.saddr4, sizeof( sockaddr_in ) );
		saddr.saddr4.sin_family = AF_INET;
		saddr.saddr4.sin_addr.s_addr = inet_addr( (yysemantic_stack_[(4) - (3)].bval)->text() );
		saddr.saddr4.sin_port = htons( (yysemantic_stack_[(4) - (4)].ival) );

		if( iked.socket_create( saddr, false ) != LIBIKE_OK )
			error( (yyloc), std::string( "daemon network configuration failed" ) );

		delete (yysemantic_stack_[(4) - (3)].bval);
	}
    break;

  case 16:

/* Line 677 of lalr1.cc  */
#line 292 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		IKE_SADDR saddr;
		memset( &saddr, 0, sizeof( saddr ) );
		SET_SALEN( &saddr.saddr4, sizeof( sockaddr_in ) );
		saddr.saddr4.sin_family = AF_INET;
		saddr.saddr4.sin_port = htons( (yysemantic_stack_[(3) - (3)].ival) );

		if( iked.socket_create( saddr, true ) != LIBIKE_OK )
			error( (yyloc), std::string( "daemon network configuration failed" ) );
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 18:

/* Line 677 of lalr1.cc  */
#line 308 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		IKE_SADDR saddr;
		memset( &saddr, 0, sizeof( saddr ) );
		SET_SALEN( &saddr.saddr4, sizeof( sockaddr_in ) );
		saddr.saddr4.sin_family = AF_INET;
		saddr.saddr4.sin_addr.s_addr = inet_addr( (yysemantic_stack_[(4) - (3)].bval)->text() );
		saddr.saddr4.sin_port = htons( (yysemantic_stack_[(4) - (4)].ival) );

		if( iked.socket_create( saddr, true ) != LIBIKE_OK )
			error( (yyloc), std::string( "daemon network configuration failed" ) );

		delete (yysemantic_stack_[(4) - (3)].bval);
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 20:

/* Line 677 of lalr1.cc  */
#line 327 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		snprintf( iked.path_log, MAX_PATH, "iked" );
		iked.logflags |= LOGFLAG_SYSTEM;
	}
    break;

  case 22:

/* Line 677 of lalr1.cc  */
#line 333 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		snprintf( iked.path_log, MAX_PATH, "%s", (yysemantic_stack_[(2) - (2)].bval)->text() );
		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 24:

/* Line 677 of lalr1.cc  */
#line 339 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.level = LLOG_NONE;
	}
    break;

  case 26:

/* Line 677 of lalr1.cc  */
#line 344 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.level = LLOG_ERROR;
	}
    break;

  case 28:

/* Line 677 of lalr1.cc  */
#line 349 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.level = LLOG_INFO;
	}
    break;

  case 30:

/* Line 677 of lalr1.cc  */
#line 354 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.level = LLOG_DEBUG;
	}
    break;

  case 32:

/* Line 677 of lalr1.cc  */
#line 359 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.level = LLOG_LOUD;
	}
    break;

  case 34:

/* Line 677 of lalr1.cc  */
#line 364 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.level = LLOG_DECODE;
	}
    break;

  case 36:

/* Line 677 of lalr1.cc  */
#line 369 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		snprintf( iked.path_decrypt, MAX_PATH, "%s", (yysemantic_stack_[(2) - (2)].bval)->text() );
		iked.dump_decrypt = true;
		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 38:

/* Line 677 of lalr1.cc  */
#line 376 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		snprintf( iked.path_encrypt, MAX_PATH, "%s", (yysemantic_stack_[(2) - (2)].bval)->text() );
		iked.dump_encrypt = true;
		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 40:

/* Line 677 of lalr1.cc  */
#line 383 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.retry_delay = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 42:

/* Line 677 of lalr1.cc  */
#line 388 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.retry_count = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 44:

/* Line 677 of lalr1.cc  */
#line 401 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		idlist = new IDB_LIST_PH2ID;
		if( idlist == NULL )
			error( (yyloc), std::string( "unable to allocate idlist for netgroup" ) + (yysemantic_stack_[(2) - (2)].bval)->text() );

		idlist->name.set( *(yysemantic_stack_[(2) - (2)].bval) );
		iked.idb_list_netgrp.add_entry( idlist );
		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 48:

/* Line 677 of lalr1.cc  */
#line 418 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		char * pos = strchr( (yysemantic_stack_[(1) - (1)].bval)->text(), '/' );
		*pos = '\0';

		IKE_PH2ID ph2id;
		memset( &ph2id, 0, sizeof( ph2id ) );
		ph2id.type = ISAKMP_ID_IPV4_ADDR_SUBNET;
		ph2id.addr1.s_addr = inet_addr( (yysemantic_stack_[(1) - (1)].bval)->text() );
		ph2id.addr2.s_addr = 0;

		long bits = strtol( pos + 1, NULL, 10 );
		for( long i = 0; i < bits; i++ )
		{
			ph2id.addr2.s_addr >>= 1;
			ph2id.addr2.s_addr |= 0x80000000;
		}

		ph2id.addr2.s_addr = htonl( ph2id.addr2.s_addr );

		idlist->add( ph2id );
		delete (yysemantic_stack_[(1) - (1)].bval);
	}
    break;

  case 50:

/* Line 677 of lalr1.cc  */
#line 450 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifndef OPT_LDAP
		error( (yyloc), std::string( "iked was compiled without ldap support" ) );
#endif
	}
    break;

  case 54:

/* Line 677 of lalr1.cc  */
#line 463 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		if( ( (yysemantic_stack_[(2) - (2)].ival) < 2 ) && ( (yysemantic_stack_[(2) - (2)].ival) > 3 ) )
			error( (yyloc), std::string( "ldap version must be 2 or 3" ) );

		iked.xauth_ldap.version = (yysemantic_stack_[(2) - (2)].ival);
#endif
	}
    break;

  case 56:

/* Line 677 of lalr1.cc  */
#line 473 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.url.set( *(yysemantic_stack_[(2) - (2)].bval) );
		delete (yysemantic_stack_[(2) - (2)].bval);
#endif
	}
    break;

  case 58:

/* Line 677 of lalr1.cc  */
#line 481 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.base.set( *(yysemantic_stack_[(2) - (2)].bval) );
		delete (yysemantic_stack_[(2) - (2)].bval);
#endif
	}
    break;

  case 60:

/* Line 677 of lalr1.cc  */
#line 489 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.subtree = true;
#endif
	}
    break;

  case 62:

/* Line 677 of lalr1.cc  */
#line 496 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.subtree = false;
#endif
	}
    break;

  case 64:

/* Line 677 of lalr1.cc  */
#line 503 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.bind_dn.set( *(yysemantic_stack_[(2) - (2)].bval) );
		delete (yysemantic_stack_[(2) - (2)].bval);
#endif
	}
    break;

  case 66:

/* Line 677 of lalr1.cc  */
#line 511 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.bind_pw.set( *(yysemantic_stack_[(2) - (2)].bval) );
		delete (yysemantic_stack_[(2) - (2)].bval);
#endif
	}
    break;

  case 68:

/* Line 677 of lalr1.cc  */
#line 519 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.attr_user.set( *(yysemantic_stack_[(2) - (2)].bval) );
		delete (yysemantic_stack_[(2) - (2)].bval);
#endif
	}
    break;

  case 70:

/* Line 677 of lalr1.cc  */
#line 527 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.attr_group.set( *(yysemantic_stack_[(2) - (2)].bval) );
		delete (yysemantic_stack_[(2) - (2)].bval);
#endif
	}
    break;

  case 72:

/* Line 677 of lalr1.cc  */
#line 535 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		iked.xauth_ldap.attr_member.set( *(yysemantic_stack_[(2) - (2)].bval) );
		delete (yysemantic_stack_[(2) - (2)].bval);
#endif
	}
    break;

  case 77:

/* Line 677 of lalr1.cc  */
#line 558 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= ( IPSEC_OPTS_ADDR | IPSEC_OPTS_MASK );

		char * pos = strchr( (yysemantic_stack_[(2) - (2)].bval)->text(), '/' );
		*pos = '\0';

		in_addr base;
		base.s_addr = inet_addr( (yysemantic_stack_[(2) - (2)].bval)->text() );
		long bits = strtol( pos + 1, NULL, 10 );

		iked.xconf_local.pool4_set( base, bits, 0 );
		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 79:

/* Line 677 of lalr1.cc  */
#line 573 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= ( IPSEC_OPTS_ADDR | IPSEC_OPTS_MASK );

		char * pos = strchr( (yysemantic_stack_[(3) - (2)].bval)->text(), '/' );
		*pos = '\0';

		in_addr base;
		base.s_addr = inet_addr( (yysemantic_stack_[(3) - (2)].bval)->text() );
		long bits = strtol( pos + 1, NULL, 10 );

		iked.xconf_local.pool4_set( base, bits, (yysemantic_stack_[(3) - (3)].ival) );
		delete (yysemantic_stack_[(3) - (2)].bval);
	}
    break;

  case 81:

/* Line 677 of lalr1.cc  */
#line 588 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= IPSEC_OPTS_DNSS;
	}
    break;

  case 83:

/* Line 677 of lalr1.cc  */
#line 593 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= IPSEC_OPTS_NBNS;
	}
    break;

  case 85:

/* Line 677 of lalr1.cc  */
#line 598 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= IPSEC_OPTS_DOMAIN;

		long len = (yysemantic_stack_[(2) - (2)].bval)->size();
		if( len >= CONF_STRLEN )
			len = CONF_STRLEN - 1;

		memcpy( iked.xconf_local.config.nscfg.dnss_suffix, (yysemantic_stack_[(2) - (2)].bval)->text(), len );
		iked.xconf_local.config.nscfg.dnss_suffix[ len ] = 0;
		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 87:

/* Line 677 of lalr1.cc  */
#line 611 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= IPSEC_OPTS_SPLITDNS;
	}
    break;

  case 89:

/* Line 677 of lalr1.cc  */
#line 616 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= IPSEC_OPTS_BANNER;

		FILE * fp = fopen( (yysemantic_stack_[(2) - (2)].bval)->text(), "r" );
		if( fp == NULL )
			error( (yyloc), std::string( "unable to load file " ) + (yysemantic_stack_[(2) - (2)].bval)->text() );

		long size;
		char buff[ CONF_STRLEN ];
		while( ( size = fread( buff, 1, CONF_STRLEN, fp ) ) > 0 )
			iked.xconf_local.banner.add( buff, size );
		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 91:

/* Line 677 of lalr1.cc  */
#line 631 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.config.opts |= IPSEC_OPTS_PFS;
		iked.xconf_local.config.dhgr = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 95:

/* Line 677 of lalr1.cc  */
#line 644 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		int count = iked.xconf_local.config.nscfg.dnss_count;
		if( count <= IPSEC_DNSS_MAX )
		{
			iked.xconf_local.config.nscfg.dnss_list[ count ].s_addr =
				inet_addr( (yysemantic_stack_[(1) - (1)].bval)->text() );
			iked.xconf_local.config.nscfg.dnss_count++;
		}
		delete (yysemantic_stack_[(1) - (1)].bval);
	}
    break;

  case 98:

/* Line 677 of lalr1.cc  */
#line 662 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		int count = iked.xconf_local.config.nscfg.nbns_count;
		if( count <= IPSEC_NBNS_MAX )
		{
			iked.xconf_local.config.nscfg.nbns_list[ count ].s_addr =
				inet_addr( (yysemantic_stack_[(1) - (1)].bval)->text() );
			iked.xconf_local.config.nscfg.nbns_count++;
		}
		delete (yysemantic_stack_[(1) - (1)].bval);
	}
    break;

  case 101:

/* Line 677 of lalr1.cc  */
#line 680 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		iked.xconf_local.domains.add( *(yysemantic_stack_[(1) - (1)].bval) );
		delete (yysemantic_stack_[(1) - (1)].bval);
	}
    break;

  case 102:

/* Line 677 of lalr1.cc  */
#line 694 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		//
		// new peer object
		//

		peer = new IDB_PEER( NULL );

		//
		// set peer default values
		//

		peer->contact = IPSEC_CONTACT_BOTH;
		peer->natt_rate = 30;
		peer->dpd_delay = 15;
		peer->dpd_retry = 5;
		peer->frag_ike_size = 520;
		peer->frag_esp_size = 520;
		peer->life_check = LTIME_CLAIM;
		SET_SALEN( &peer->saddr.saddr4, sizeof( sockaddr_in ) );
		peer->saddr.saddr4.sin_family = AF_INET;
		peer->saddr.saddr4.sin_port = htons( LIBIKE_IKE_PORT );
		peer->saddr.saddr4.sin_addr.s_addr = inet_addr( (yysemantic_stack_[(2) - (2)].bval)->text() );

		peer->xauth_source = &iked.xauth_local;
		peer->xconf_source = &iked.xconf_local;
		peer->xconf_mode = CONFIG_MODE_PULL;

		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 103:

/* Line 677 of lalr1.cc  */
#line 724 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->add( true );
		peer->dec( true );
	}
    break;

  case 104:

/* Line 677 of lalr1.cc  */
#line 729 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		//
		// new peer object
		//

		peer = new IDB_PEER( NULL );

		//
		// set peer default values
		//

		peer->contact = IPSEC_CONTACT_BOTH;
		peer->natt_rate = 30;
		peer->dpd_delay = 15;
		peer->dpd_retry = 5;
		peer->frag_ike_size = 520;
		peer->frag_esp_size = 520;
		peer->life_check = LTIME_CLAIM;
		SET_SALEN( &peer->saddr.saddr4, sizeof( sockaddr_in ) );
		peer->saddr.saddr4.sin_family = AF_INET;
		peer->saddr.saddr4.sin_port = htons( (yysemantic_stack_[(3) - (3)].ival) );
		peer->saddr.saddr4.sin_addr.s_addr = inet_addr( (yysemantic_stack_[(3) - (2)].bval)->text() );

		peer->xauth_source = &iked.xauth_local;
		peer->xconf_source = &iked.xconf_local;
		peer->xconf_mode = CONFIG_MODE_PULL;

		delete (yysemantic_stack_[(3) - (2)].bval);
	}
    break;

  case 105:

/* Line 677 of lalr1.cc  */
#line 759 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->add( true );
		peer->dec( true );
	}
    break;

  case 108:

/* Line 677 of lalr1.cc  */
#line 770 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->contact = IPSEC_CONTACT_INIT;
	}
    break;

  case 110:

/* Line 677 of lalr1.cc  */
#line 775 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->contact = IPSEC_CONTACT_RESP;
	}
    break;

  case 112:

/* Line 677 of lalr1.cc  */
#line 780 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->exchange = ISAKMP_EXCH_IDENT_PROTECT;
	}
    break;

  case 114:

/* Line 677 of lalr1.cc  */
#line 785 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->exchange = ISAKMP_EXCH_AGGRESSIVE;
	}
    break;

  case 116:

/* Line 677 of lalr1.cc  */
#line 790 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		peer->natt_mode = IPSEC_NATT_ENABLE;
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 118:

/* Line 677 of lalr1.cc  */
#line 799 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		peer->natt_mode = IPSEC_NATT_DISABLE;
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 120:

/* Line 677 of lalr1.cc  */
#line 808 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		peer->natt_mode = IPSEC_NATT_FORCE_RFC;
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 122:

/* Line 677 of lalr1.cc  */
#line 817 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		peer->natt_mode = IPSEC_NATT_FORCE_DRAFT;
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 124:

/* Line 677 of lalr1.cc  */
#line 826 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		peer->natt_mode = IPSEC_NATT_FORCE_RFC;
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 126:

/* Line 677 of lalr1.cc  */
#line 835 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_NATT
		peer->natt_rate = (yysemantic_stack_[(2) - (2)].ival);
#else
		error( (yyloc), std::string( "iked was compiled without NATT support" ) );
#endif
	}
    break;

  case 128:

/* Line 677 of lalr1.cc  */
#line 844 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->dpd_mode = IPSEC_DPD_ENABLE;
	}
    break;

  case 130:

/* Line 677 of lalr1.cc  */
#line 849 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->dpd_mode = IPSEC_DPD_DISABLE;
	}
    break;

  case 132:

/* Line 677 of lalr1.cc  */
#line 854 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->dpd_mode = IPSEC_DPD_FORCE;
	}
    break;

  case 134:

/* Line 677 of lalr1.cc  */
#line 859 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->dpd_delay = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 136:

/* Line 677 of lalr1.cc  */
#line 864 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->dpd_retry = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 138:

/* Line 677 of lalr1.cc  */
#line 869 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->frag_ike_mode = IPSEC_FRAG_ENABLE;
	}
    break;

  case 140:

/* Line 677 of lalr1.cc  */
#line 874 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->frag_ike_mode = IPSEC_FRAG_DISABLE;
	}
    break;

  case 142:

/* Line 677 of lalr1.cc  */
#line 879 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->frag_ike_mode = IPSEC_FRAG_FORCE;
	}
    break;

  case 144:

/* Line 677 of lalr1.cc  */
#line 884 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->frag_ike_size = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 146:

/* Line 677 of lalr1.cc  */
#line 889 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->frag_esp_mode = IPSEC_FRAG_ENABLE;
	}
    break;

  case 148:

/* Line 677 of lalr1.cc  */
#line 894 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->frag_esp_mode = IPSEC_FRAG_DISABLE;
	}
    break;

  case 150:

/* Line 677 of lalr1.cc  */
#line 899 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->frag_esp_size = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 152:

/* Line 677 of lalr1.cc  */
#line 904 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_l = ISAKMP_ID_IPV4_ADDR;
	}
    break;

  case 154:

/* Line 677 of lalr1.cc  */
#line 909 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_l = ISAKMP_ID_IPV4_ADDR;
		peer->iddata_l.set( *(yysemantic_stack_[(4) - (4)].bval) );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 156:

/* Line 677 of lalr1.cc  */
#line 916 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_l = ISAKMP_ID_FQDN;
		peer->iddata_l.set( (yysemantic_stack_[(4) - (4)].bval)->buff(), (yysemantic_stack_[(4) - (4)].bval)->size() - 1 );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 158:

/* Line 677 of lalr1.cc  */
#line 923 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_l = ISAKMP_ID_USER_FQDN;
		peer->iddata_l.set( (yysemantic_stack_[(4) - (4)].bval)->buff(), (yysemantic_stack_[(4) - (4)].bval)->size() - 1 );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 160:

/* Line 677 of lalr1.cc  */
#line 930 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_l = ISAKMP_ID_KEY_ID;
		peer->iddata_l.set( (yysemantic_stack_[(4) - (4)].bval)->buff(), (yysemantic_stack_[(4) - (4)].bval)->size() - 1 );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 162:

/* Line 677 of lalr1.cc  */
#line 937 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_l = ISAKMP_ID_ASN1_DN;
	}
    break;

  case 164:

/* Line 677 of lalr1.cc  */
#line 942 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_l = ISAKMP_ID_ASN1_DN;
		peer->iddata_l.set( *(yysemantic_stack_[(4) - (4)].bval) );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 166:

/* Line 677 of lalr1.cc  */
#line 949 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_r = ISAKMP_ID_IPV4_ADDR;
	}
    break;

  case 168:

/* Line 677 of lalr1.cc  */
#line 954 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_r = ISAKMP_ID_IPV4_ADDR;
		peer->iddata_r.set( *(yysemantic_stack_[(4) - (4)].bval) );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 170:

/* Line 677 of lalr1.cc  */
#line 961 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_r = ISAKMP_ID_FQDN;
		peer->iddata_r.set( (yysemantic_stack_[(4) - (4)].bval)->buff(), (yysemantic_stack_[(4) - (4)].bval)->size() - 1 );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 172:

/* Line 677 of lalr1.cc  */
#line 968 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_r = ISAKMP_ID_USER_FQDN;
		peer->iddata_r.set( (yysemantic_stack_[(4) - (4)].bval)->buff(), (yysemantic_stack_[(4) - (4)].bval)->size() - 1 );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 174:

/* Line 677 of lalr1.cc  */
#line 975 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_r = ISAKMP_ID_KEY_ID;
		peer->iddata_r.set( (yysemantic_stack_[(4) - (4)].bval)->buff(), (yysemantic_stack_[(4) - (4)].bval)->size() - 1 );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 176:

/* Line 677 of lalr1.cc  */
#line 982 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_r = ISAKMP_ID_ASN1_DN;
	}
    break;

  case 178:

/* Line 677 of lalr1.cc  */
#line 987 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->idtype_r = ISAKMP_ID_ASN1_DN;
		peer->iddata_r.set( *(yysemantic_stack_[(4) - (4)].bval) );
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 180:

/* Line 677 of lalr1.cc  */
#line 994 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->psk.set( *(yysemantic_stack_[(3) - (3)].bval) );
		delete (yysemantic_stack_[(3) - (3)].bval);
	}
    break;

  case 182:

/* Line 677 of lalr1.cc  */
#line 1000 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->fpass.del();

		if( iked.cert_load(
			peer->cert_r,
			(yysemantic_stack_[(3) - (3)].bval)->text(),
			true,
			peer->fpass ) != FILE_OK )
			error( (yyloc), std::string( "unable to load file " ) + (yysemantic_stack_[(3) - (3)].bval)->text() );
		delete (yysemantic_stack_[(3) - (3)].bval);
	}
    break;

  case 184:

/* Line 677 of lalr1.cc  */
#line 1013 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->fpass.set( *(yysemantic_stack_[(4) - (4)].bval) );

		if( iked.cert_load(
			peer->cert_r,
			(yysemantic_stack_[(4) - (3)].bval)->text(),
			true,
			peer->fpass ) != FILE_OK )
			error( (yyloc), std::string( "unable to load file " ) + (yysemantic_stack_[(4) - (3)].bval)->text() );

		delete (yysemantic_stack_[(4) - (3)].bval);
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 186:

/* Line 677 of lalr1.cc  */
#line 1028 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->fpass.del();
		
		if( iked.cert_load(
			peer->cert_l,
			(yysemantic_stack_[(3) - (3)].bval)->text(),
			false,
			peer->fpass ) != FILE_OK )
			error( (yyloc), std::string( "unable to load file " ) + (yysemantic_stack_[(3) - (3)].bval)->text() );

		delete (yysemantic_stack_[(3) - (3)].bval);
	}
    break;

  case 188:

/* Line 677 of lalr1.cc  */
#line 1042 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->fpass.set( *(yysemantic_stack_[(4) - (4)].bval) );
		
		if( iked.cert_load(
			peer->cert_l,
			(yysemantic_stack_[(4) - (3)].bval)->text(),
			false,
			peer->fpass ) != FILE_OK )
			error( (yyloc), std::string( "unable to load file " ) + (yysemantic_stack_[(4) - (3)].bval)->text() );

		delete (yysemantic_stack_[(4) - (3)].bval);
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 190:

/* Line 677 of lalr1.cc  */
#line 1057 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->fpass.del();
		
		if( iked.prvkey_rsa_load(
			&peer->key,
			(yysemantic_stack_[(3) - (3)].bval)->text(),
			peer->fpass ) != FILE_OK )
			error( (yyloc), std::string( "unable to load file " ) + (yysemantic_stack_[(3) - (3)].bval)->text() );

		delete (yysemantic_stack_[(3) - (3)].bval);
	}
    break;

  case 192:

/* Line 677 of lalr1.cc  */
#line 1070 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->fpass.set( *(yysemantic_stack_[(4) - (4)].bval) );
		
		if( iked.prvkey_rsa_load(
			&peer->key,
			(yysemantic_stack_[(4) - (3)].bval)->text(),
			peer->fpass ) != FILE_OK )
			error( (yyloc), std::string( "unable to load file " ) + (yysemantic_stack_[(4) - (3)].bval)->text() );

		delete (yysemantic_stack_[(4) - (3)].bval);
		delete (yysemantic_stack_[(4) - (4)].bval);
	}
    break;

  case 194:

/* Line 677 of lalr1.cc  */
#line 1084 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->life_check = LTIME_OBEY;
	}
    break;

  case 196:

/* Line 677 of lalr1.cc  */
#line 1089 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->life_check = LTIME_CLAIM;
	}
    break;

  case 198:

/* Line 677 of lalr1.cc  */
#line 1094 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->life_check = LTIME_STRICT;
	}
    break;

  case 200:

/* Line 677 of lalr1.cc  */
#line 1099 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->life_check = LTIME_EXACT;
	}
    break;

  case 202:

/* Line 677 of lalr1.cc  */
#line 1104 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->xauth_source = &iked.xauth_local;
	}
    break;

  case 204:

/* Line 677 of lalr1.cc  */
#line 1109 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->xauth_source = &iked.xauth_local;
		peer->xauth_group.set( *(yysemantic_stack_[(3) - (3)].bval) );
		delete (yysemantic_stack_[(3) - (3)].bval);
	}
    break;

  case 206:

/* Line 677 of lalr1.cc  */
#line 1116 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		if( !iked.xauth_ldap.url.size() )
			error( (yyloc), std::string( "conf source is ldap but no url is defined" ) );

		peer->xauth_source = &iked.xauth_ldap;
#else
		error( (yyloc), std::string( "iked was compiled without ldap support" ) );
#endif
	}
    break;

  case 208:

/* Line 677 of lalr1.cc  */
#line 1128 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
#ifdef OPT_LDAP
		if( !iked.xauth_ldap.url.size() )
			error( (yyloc), std::string( "conf source is ldap but no url is defined" ) );

		peer->xauth_source = &iked.xauth_ldap;
		peer->xauth_group.set( *(yysemantic_stack_[(3) - (3)].bval) );
		delete (yysemantic_stack_[(3) - (3)].bval);
#else
		error( (yyloc), std::string( "iked was compiled without ldap support" ) );
#endif
	}
    break;

  case 210:

/* Line 677 of lalr1.cc  */
#line 1142 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->xconf_source = &iked.xconf_local;
		peer->xconf_mode = CONFIG_MODE_PULL;
	}
    break;

  case 212:

/* Line 677 of lalr1.cc  */
#line 1148 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->xconf_source = &iked.xconf_local;
		peer->xconf_mode = CONFIG_MODE_PULL;
	}
    break;

  case 214:

/* Line 677 of lalr1.cc  */
#line 1154 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->xconf_source = &iked.xconf_local;
		peer->xconf_mode = CONFIG_MODE_PUSH;
	}
    break;

  case 216:

/* Line 677 of lalr1.cc  */
#line 1160 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->plcy_mode = POLICY_MODE_DISABLE;
	}
    break;

  case 218:

/* Line 677 of lalr1.cc  */
#line 1165 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->plcy_mode = POLICY_MODE_COMPAT;
	}
    break;

  case 220:

/* Line 677 of lalr1.cc  */
#line 1170 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->plcy_mode = POLICY_MODE_CONFIG;
	}
    break;

  case 223:

/* Line 677 of lalr1.cc  */
#line 1176 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		memset( &proposal, 0, sizeof( proposal ) );
		proposal.proto = ISAKMP_PROTO_ISAKMP;
		proposal.xform = ISAKMP_KEY_IKE;
		proposal.dhgr_id = IKE_GRP_GROUP2;
	}
    break;

  case 224:

/* Line 677 of lalr1.cc  */
#line 1183 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->proposals.add( &proposal, true );
	}
    break;

  case 225:

/* Line 677 of lalr1.cc  */
#line 1187 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		memset( &proposal, 0, sizeof( proposal ) );
		proposal.proto = ISAKMP_PROTO_IPSEC_AH;
	}
    break;

  case 226:

/* Line 677 of lalr1.cc  */
#line 1192 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->proposals.add( &proposal, true );
	}
    break;

  case 227:

/* Line 677 of lalr1.cc  */
#line 1196 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		memset( &proposal, 0, sizeof( proposal ) );
		proposal.proto = ISAKMP_PROTO_IPSEC_ESP;
	}
    break;

  case 228:

/* Line 677 of lalr1.cc  */
#line 1201 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->proposals.add( &proposal, true );
	}
    break;

  case 229:

/* Line 677 of lalr1.cc  */
#line 1205 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		memset( &proposal, 0, sizeof( proposal ) );
		proposal.proto = ISAKMP_PROTO_IPCOMP;
	}
    break;

  case 230:

/* Line 677 of lalr1.cc  */
#line 1210 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		peer->proposals.add( &proposal, true );
	}
    break;

  case 233:

/* Line 677 of lalr1.cc  */
#line 1221 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		long index = 0;
		while( true )
		{
			idlist = static_cast<IDB_LIST_PH2ID*>( iked.idb_list_netgrp.get_entry( index++ ) );
			if( idlist == NULL )
				break;

			if( !strcmp( (yysemantic_stack_[(2) - (2)].bval)->text(), idlist->name.text() ) )
				break; 
		}

		if( idlist == NULL )
			error( (yyloc), std::string( "unknown netgroup " ) + (yysemantic_stack_[(2) - (2)].bval)->text() );

		peer->netmaps.add( idlist, UNITY_SPLIT_INCLUDE, NULL );

		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 235:

/* Line 677 of lalr1.cc  */
#line 1242 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		long index = 0;
		while( true )
		{
			idlist = static_cast<IDB_LIST_PH2ID*>( iked.idb_list_netgrp.get_entry( index++ ) );
			if( idlist == NULL )
				break;

			if( !strcmp( (yysemantic_stack_[(3) - (2)].bval)->text(), idlist->name.text() ) )
				break; 
		}

		if( idlist == NULL )
			error( (yyloc), std::string( "unknown netgroup " ) + (yysemantic_stack_[(3) - (2)].bval)->text() );

		peer->netmaps.add( idlist, UNITY_SPLIT_INCLUDE, (yysemantic_stack_[(3) - (3)].bval) );

		delete (yysemantic_stack_[(3) - (2)].bval);
		delete (yysemantic_stack_[(3) - (3)].bval);
	}
    break;

  case 237:

/* Line 677 of lalr1.cc  */
#line 1264 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		long index = 0;
		while( true )
		{
			idlist = static_cast<IDB_LIST_PH2ID*>( iked.idb_list_netgrp.get_entry( index++ ) );
			if( idlist == NULL )
				break;

			if( !strcmp( (yysemantic_stack_[(2) - (2)].bval)->text(), idlist->name.text() ) )
				break; 
		}

		if( idlist == NULL )
			error( (yyloc), std::string( "unknown netgroup " ) + (yysemantic_stack_[(2) - (2)].bval)->text() );

		peer->netmaps.add( idlist, UNITY_SPLIT_EXCLUDE, NULL );

		delete (yysemantic_stack_[(2) - (2)].bval);
	}
    break;

  case 239:

/* Line 677 of lalr1.cc  */
#line 1285 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		long index = 0;
		while( true )
		{
			idlist = static_cast<IDB_LIST_PH2ID*>( iked.idb_list_netgrp.get_entry( index++ ) );
			if( idlist == NULL )
				break;

			if( !strcmp( (yysemantic_stack_[(3) - (2)].bval)->text(), idlist->name.text() ) )
				break; 
		}

		if( idlist == NULL )
			error( (yyloc), std::string( "unknown netgroup " ) + (yysemantic_stack_[(3) - (2)].bval)->text() );

		peer->netmaps.add( idlist, UNITY_SPLIT_EXCLUDE, (yysemantic_stack_[(3) - (3)].bval) );

		delete (yysemantic_stack_[(3) - (2)].bval);
		delete (yysemantic_stack_[(3) - (3)].bval);
	}
    break;

  case 243:

/* Line 677 of lalr1.cc  */
#line 1314 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.auth_id = HYBRID_AUTH_INIT_RSA;
	}
    break;

  case 245:

/* Line 677 of lalr1.cc  */
#line 1319 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.auth_id = XAUTH_AUTH_INIT_RSA;
	}
    break;

  case 247:

/* Line 677 of lalr1.cc  */
#line 1324 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.auth_id = XAUTH_AUTH_INIT_PSK;
	}
    break;

  case 249:

/* Line 677 of lalr1.cc  */
#line 1329 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.auth_id = IKE_AUTH_SIG_RSA;
	}
    break;

  case 251:

/* Line 677 of lalr1.cc  */
#line 1334 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.auth_id = IKE_AUTH_PRESHARED_KEY;
	}
    break;

  case 253:

/* Line 677 of lalr1.cc  */
#line 1339 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.ciph_id = IKE_CIPHER_AES;
	}
    break;

  case 255:

/* Line 677 of lalr1.cc  */
#line 1344 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.ciph_id = IKE_CIPHER_BLOWFISH;
	}
    break;

  case 257:

/* Line 677 of lalr1.cc  */
#line 1349 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.ciph_id = IKE_CIPHER_3DES;
	}
    break;

  case 259:

/* Line 677 of lalr1.cc  */
#line 1354 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.ciph_id = IKE_CIPHER_CAST;
	}
    break;

  case 261:

/* Line 677 of lalr1.cc  */
#line 1359 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.ciph_id = IKE_CIPHER_DES;
	}
    break;

  case 263:

/* Line 677 of lalr1.cc  */
#line 1364 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.ciph_kl = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 265:

/* Line 677 of lalr1.cc  */
#line 1369 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.hash_id = IKE_HASH_MD5;
	}
    break;

  case 267:

/* Line 677 of lalr1.cc  */
#line 1374 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.hash_id = IKE_HASH_SHA1;
	}
    break;

  case 269:

/* Line 677 of lalr1.cc  */
#line 1379 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		switch( (yysemantic_stack_[(2) - (2)].ival) )
		{
			case 1:
				proposal.dhgr_id = IKE_GRP_GROUP1;
				break;

			case 2:
				proposal.dhgr_id = IKE_GRP_GROUP2;
				break;

			case 5:
				proposal.dhgr_id = IKE_GRP_GROUP5;
				break;

			case 14:
				proposal.dhgr_id = IKE_GRP_GROUP14;
				break;

			case 15:
				proposal.dhgr_id = IKE_GRP_GROUP15;
				break;

			case 16:
				proposal.dhgr_id = IKE_GRP_GROUP16;
				break;

			default:
				error( (yyloc), std::string( "invalid dhgrp id" ) );
				break;
		}
	}
    break;

  case 271:

/* Line 677 of lalr1.cc  */
#line 1413 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_sec = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 273:

/* Line 677 of lalr1.cc  */
#line 1418 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_kbs = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 277:

/* Line 677 of lalr1.cc  */
#line 1430 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_AH_MD5;
		proposal.hash_id = ISAKMP_AUTH_HMAC_MD5;
	}
    break;

  case 279:

/* Line 677 of lalr1.cc  */
#line 1436 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_AH_SHA;
		proposal.hash_id = ISAKMP_AUTH_HMAC_SHA;
	}
    break;

  case 281:

/* Line 677 of lalr1.cc  */
#line 1442 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		switch( (yysemantic_stack_[(2) - (2)].ival) )
		{
			case 1:
				proposal.dhgr_id = IKE_GRP_GROUP1;
				break;

			case 2:
				proposal.dhgr_id = IKE_GRP_GROUP2;
				break;

			case 5:
				proposal.dhgr_id = IKE_GRP_GROUP5;
				break;

			case 14:
				proposal.dhgr_id = IKE_GRP_GROUP14;
				break;

			case 15:
				proposal.dhgr_id = IKE_GRP_GROUP15;
				break;

			case 16:
				proposal.dhgr_id = IKE_GRP_GROUP16;
				break;

			default:
				error( (yyloc), std::string( "invalid dhgrp id" ) );
				break;
		}
	}
    break;

  case 283:

/* Line 677 of lalr1.cc  */
#line 1476 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_sec = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 285:

/* Line 677 of lalr1.cc  */
#line 1481 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_kbs = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 289:

/* Line 677 of lalr1.cc  */
#line 1493 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_ESP_AES;
	}
    break;

  case 291:

/* Line 677 of lalr1.cc  */
#line 1498 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_ESP_BLOWFISH;
	}
    break;

  case 293:

/* Line 677 of lalr1.cc  */
#line 1503 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_ESP_3DES;
	}
    break;

  case 295:

/* Line 677 of lalr1.cc  */
#line 1508 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_ESP_CAST;
	}
    break;

  case 297:

/* Line 677 of lalr1.cc  */
#line 1513 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_ESP_DES;
	}
    break;

  case 299:

/* Line 677 of lalr1.cc  */
#line 1518 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.ciph_kl = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 301:

/* Line 677 of lalr1.cc  */
#line 1523 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.hash_id = ISAKMP_AUTH_HMAC_MD5;
	}
    break;

  case 303:

/* Line 677 of lalr1.cc  */
#line 1528 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.hash_id = ISAKMP_AUTH_HMAC_SHA;
	}
    break;

  case 305:

/* Line 677 of lalr1.cc  */
#line 1533 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		switch( (yysemantic_stack_[(2) - (2)].ival) )
		{
			case 1:
				proposal.dhgr_id = IKE_GRP_GROUP1;
				break;

			case 2:
				proposal.dhgr_id = IKE_GRP_GROUP2;
				break;

			case 5:
				proposal.dhgr_id = IKE_GRP_GROUP5;
				break;

			case 14:
				proposal.dhgr_id = IKE_GRP_GROUP14;
				break;

			case 15:
				proposal.dhgr_id = IKE_GRP_GROUP15;
				break;

			case 16:
				proposal.dhgr_id = IKE_GRP_GROUP16;
				break;

			default:
				error( (yyloc), std::string( "invalid dhgrp id" ) );
				break;
		}
	}
    break;

  case 307:

/* Line 677 of lalr1.cc  */
#line 1567 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_sec = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 309:

/* Line 677 of lalr1.cc  */
#line 1572 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_kbs = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 313:

/* Line 677 of lalr1.cc  */
#line 1584 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_IPCOMP_DEFLATE;
	}
    break;

  case 315:

/* Line 677 of lalr1.cc  */
#line 1589 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.xform = ISAKMP_IPCOMP_LZS;
	}
    break;

  case 317:

/* Line 677 of lalr1.cc  */
#line 1594 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_sec = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;

  case 319:

/* Line 677 of lalr1.cc  */
#line 1599 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"
    {
		proposal.life_kbs = (yysemantic_stack_[(2) - (2)].ival);
	}
    break;



/* Line 677 of lalr1.cc  */
#line 2302 "conf.parse.cpp"
	default:
          break;
      }
    YY_SYMBOL_PRINT ("-> $$ =", yyr1_[yyn], &yyval, &yyloc);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push (yyval);
    yylocation_stack_.push (yyloc);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

  /*------------------------------------.
  | yyerrlab -- here on detecting error |
  `------------------------------------*/
  yyerrlab:
    /* If not already recovering from an error, report this error.  */
    if (!yyerrstatus_)
      {
	++yynerrs_;
	error (yylloc, yysyntax_error_ (yystate, yytoken));
      }

    yyerror_range[0] = yylloc;
    if (yyerrstatus_ == 3)
      {
	/* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

	if (yychar <= yyeof_)
	  {
	  /* Return failure if at end of input.  */
	  if (yychar == yyeof_)
	    YYABORT;
	  }
	else
	  {
	    yydestruct_ ("Error: discarding", yytoken, &yylval, &yylloc);
	    yychar = yyempty_;
	  }
      }

    /* Else will try to reuse lookahead token after shifting the error
       token.  */
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;

    yyerror_range[0] = yylocation_stack_[yylen - 1];
    /* Do not reclaim the symbols of the rule which action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    yystate = yystate_stack_[0];
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

    for (;;)
      {
	yyn = yypact_[yystate];
	if (yyn != yypact_ninf_)
	{
	  yyn += yyterror_;
	  if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
	    {
	      yyn = yytable_[yyn];
	      if (0 < yyn)
		break;
	    }
	}

	/* Pop the current state because it cannot handle the error token.  */
	if (yystate_stack_.height () == 1)
	YYABORT;

	yyerror_range[0] = yylocation_stack_[0];
	yydestruct_ ("Error: popping",
		     yystos_[yystate],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);
	yypop_ ();
	yystate = yystate_stack_[0];
	YY_STACK_PRINT ();
      }

    yyerror_range[1] = yylloc;
    // Using YYLLOC is tempting, but would change the location of
    // the lookahead.  YYLOC is available though.
    YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
    yysemantic_stack_.push (yylval);
    yylocation_stack_.push (yyloc);

    /* Shift the error token.  */
    YY_SYMBOL_PRINT ("Shifting", yystos_[yyn],
		     &yysemantic_stack_[0], &yylocation_stack_[0]);

    yystate = yyn;
    goto yynewstate;

    /* Accept.  */
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    /* Abort.  */
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (yychar != yyempty_)
      yydestruct_ ("Cleanup: discarding lookahead", yytoken, &yylval, &yylloc);

    /* Do not reclaim the symbols of the rule which action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (yystate_stack_.height () != 1)
      {
	yydestruct_ ("Cleanup: popping",
		   yystos_[yystate_stack_[0]],
		   &yysemantic_stack_[0],
		   &yylocation_stack_[0]);
	yypop_ ();
      }

    return yyresult;
  }

  // Generate an error message.
  std::string
  conf_parser::yysyntax_error_ (int yystate, int tok)
  {
    std::string res;
    YYUSE (yystate);
#if YYERROR_VERBOSE
    int yyn = yypact_[yystate];
    if (yypact_ninf_ < yyn && yyn <= yylast_)
      {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
	  if (yycheck_[x + yyn] == x && x != yyterror_)
	    ++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char conf_parser::yypact_ninf_ = -77;
  const short int
  conf_parser::yypact_[] =
  {
       -77,    36,   -77,    62,   -41,   -77,    93,   -14,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   115,   -77,     9,     2,
     118,   -77,   143,   -77,   132,   -77,    -6,   129,   -15,     7,
      11,    47,    49,   -77,   -77,     4,   -77,    40,   -77,   -77,
      78,   -77,    81,    50,   -77,   167,   -77,   -76,   -58,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,    -4,   -77,    83,    84,    85,    25,    87,    88,    89,
      90,    94,   -77,    96,    77,    95,   -77,    98,   -77,   -77,
     -77,    -2,   -77,    97,   -77,   100,   198,   201,   204,   209,
     210,   211,   218,   219,   220,   221,   222,   223,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   224,   -77,   225,   -77,   -77,   226,   -77,   227,
     -77,   228,   -77,   229,   230,    80,   -77,    18,    -9,    15,
     114,    70,   116,   117,    91,   119,    44,   120,    21,   -62,
      -7,   -55,   172,     8,   239,    59,   -77,   238,   -77,   240,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,    79,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -50,   107,   121,   135,   136,   137,   -77,
     -77,   -77,   -77,   138,   139,    30,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   258,   -77,   259,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     260,   261,   262,   263,   264,   265,   -77,   -77,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   160,   163,   164,   165,   166,   168,   169,   171,
     173,   174,   -77,   175,   176,   177,   285,   286,   290,   296,
     -77,   297,   -77,   298,   -77,   -77,   299,   300,   301,   302,
       1,   307,   308,   309,   310,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   311,   312,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     313,   -77,   -77,   -77,   314,   -77,   -77,   315,   -77,   -77,
     -77,   316,   -77,   317,   -77,   318,   -77,   319,   -77,   320,
     -77,   -77,   -77,   -77,   321,   -77,   322,   -77,   323,   324,
     -77,   -77,   -77,   -77,   -77,   188,   189,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   325,   -77,   326,   327,   328,   -77,
     329,   330,   -77,   331,   332,   333,   -77,   334,   -77,   335,
     -77,   336,   -77,   337,   -77,   -77,   -77,   -77,   -77,   191,
     192,    -3,     3,     0,     5,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   338,
     -77,   339,   -77,    92,    69,   231,    12,   232,   233,   234,
     -77,   -77,    43,   235,   236,   237,   -77,   -77,    86,   253,
      45,   254,   255,   256,   -77,   -77,    46,   257,   280,   -77,
     340,   -77,   341,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   342,   343,   344,   345,   346,   347,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const unsigned short int
  conf_parser::yydefact_[] =
  {
         2,     0,     1,     0,     0,    50,     0,     0,     3,     4,
       5,     6,     7,     8,    10,    44,     0,    75,   102,     0,
       0,    52,     0,   104,     0,     9,     0,     0,     0,     0,
       0,     0,     0,    11,    46,     0,    74,     0,    93,    96,
       0,    99,     0,     0,    76,     0,   106,     0,     0,    24,
      26,    28,    30,    32,    34,    20,    22,    38,    36,    42,
      40,     0,    51,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,    77,    81,    83,    85,    87,    89,    91,
     106,     0,    12,     0,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    48,
      47,    54,    56,    58,    60,    62,    64,    66,    68,    70,
      72,    79,     0,    95,     0,    94,    98,     0,    97,     0,
     101,     0,   100,     0,     0,     0,   103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   107,     0,    14,     0,
      18,    25,    27,    29,    31,    33,    35,    21,    23,    39,
      37,    43,    41,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    82,    84,    86,    88,
      90,    92,   105,   108,   110,   112,   114,   116,   118,   120,
     126,   128,   130,   132,   134,   136,   138,   140,   142,   144,
     146,   148,   150,     0,     0,     0,     0,     0,     0,   194,
     196,   198,   200,   202,   206,   210,   216,   220,   218,   231,
     223,   225,   227,   229,    13,     0,    17,     0,    49,    55,
      57,    59,    61,    63,    65,    67,    69,    71,    73,    80,
       0,     0,     0,     0,     0,     0,   122,   124,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   152,     0,     0,   162,     0,   166,     0,     0,
     176,     0,   180,   182,   186,   190,     0,     0,     0,     0,
     204,     0,   208,     0,   212,   214,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    15,    19,   109,   111,   113,
     115,   117,   119,     0,     0,   121,   127,   129,   131,   133,
     135,   137,   139,   141,   143,   145,   147,   149,   151,   154,
       0,   156,   158,   164,     0,   160,   168,     0,   170,   172,
     178,     0,   174,     0,   184,     0,   188,     0,   192,     0,
     195,   197,   199,   201,     0,   203,     0,   207,     0,     0,
     211,   217,   221,   219,   222,     0,     0,   232,   241,   275,
     287,   311,   123,   125,     0,   153,     0,     0,     0,   163,
       0,     0,   167,     0,     0,     0,   177,     0,   181,     0,
     183,     0,   187,     0,   191,   205,   209,   213,   215,   233,
     237,     0,     0,     0,     0,   155,   157,   159,   165,   161,
     169,   171,   173,   179,   175,   185,   189,   193,   235,     0,
     239,     0,   224,     0,     0,     0,     0,     0,     0,     0,
     242,   226,     0,     0,     0,     0,   276,   228,     0,     0,
       0,     0,     0,     0,   288,   230,     0,     0,     0,   312,
       0,   234,     0,   238,   243,   245,   247,   249,   251,   253,
     255,   257,   259,   261,   263,   265,   267,   269,   271,   273,
     277,   279,   281,   283,   285,   289,   291,   293,   295,   297,
     299,   301,   303,   305,   307,   309,   313,   315,   317,   319,
     236,   240,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   244,   246,
     248,   250,   252,   254,   256,   258,   260,   262,   264,   266,
     268,   270,   272,   274,   278,   280,   282,   284,   286,   290,
     292,   294,   296,   298,   300,   302,   304,   306,   308,   310,
     314,   316,   318,   320
  };

  /* YYPGOTO[NTERM-NUM].  */
  const short int
  conf_parser::yypgoto_[] =
  {
       -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   348,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const short int
  conf_parser::yydefgoto_[] =
  {
        -1,     1,     8,     9,    19,    33,   147,   225,   149,   227,
      92,    93,    86,    87,    88,    89,    90,    91,    95,    94,
      97,    96,    10,    20,    61,   100,   163,    11,    16,    35,
      72,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,    12,    22,    44,   112,   174,   114,   117,   119,   121,
     123,   124,    74,   115,    75,   118,    77,   122,    13,    24,
      45,    81,   146,   240,   241,   242,   243,   244,   245,   248,
     303,   304,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   320,   364,   366,   367,   370,
     324,   368,   327,   371,   373,   374,   377,   331,   375,   333,
     335,   379,   337,   381,   339,   383,   276,   277,   278,   279,
     281,   344,   283,   346,   286,   348,   349,   287,   289,   288,
     291,   292,   293,   294,   290,   357,   409,   440,   411,   442,
     391,   420,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   392,   426,
     498,   499,   500,   501,   502,   393,   434,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   394,   439,
     514,   515,   516,   517
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const signed char conf_parser::yytable_ninf_ = -1;
  const unsigned short int
  conf_parser::yytable_[] =
  {
        98,   412,   126,    55,   427,   354,    25,   421,    62,   435,
      47,    48,   213,   205,   206,   207,   208,    26,   216,   262,
     263,   264,   265,   266,   187,   188,   189,    27,    28,    29,
      30,    31,    32,   214,   104,   105,     2,    63,    64,    65,
      66,    67,    68,    69,    70,    71,   185,   186,    82,   127,
       3,    83,   128,   200,   201,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    14,    84,     4,     5,    85,
     183,   184,   139,   209,   210,   211,   212,   140,     6,   191,
     192,   193,   141,   142,   182,    15,     7,   143,   203,   204,
     144,   246,   247,   145,   355,   356,    17,   413,   217,   218,
     196,   197,   198,   414,   415,   416,   428,   429,   417,   430,
      56,   431,   422,    18,   423,   436,   284,   285,    21,   418,
     419,    34,   432,   433,    99,   424,   425,   437,   438,   455,
     456,   127,    57,    23,   128,    46,    58,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    36,    49,    50,
      51,    52,    53,    54,   139,   220,   221,   222,   223,   140,
     460,   461,   471,   472,   141,   142,   476,   477,    73,   143,
      80,    59,   144,    60,    79,   145,   267,   268,   269,   270,
     271,   449,   450,   451,   452,   453,    37,    38,    39,    40,
      41,    42,    43,   444,   445,   446,   447,   448,   465,   466,
     467,   468,   469,    76,   113,   151,    78,   101,   152,   102,
     103,   153,   106,   107,   108,   109,   154,   155,   156,   110,
     111,   148,   116,   120,   150,   157,   158,   159,   160,   161,
     162,   175,   176,   177,   178,   179,   180,   181,   190,   215,
     194,   195,   219,   199,   202,   224,   272,   226,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     273,   274,   275,   280,   282,   295,   296,   297,   298,   299,
     300,   301,   302,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   321,   322,
     323,   325,   340,   341,   328,   326,   329,   342,   330,   332,
     334,   336,   338,   343,   345,   347,   350,   351,   352,   353,
     358,   359,   360,   361,   389,   390,   408,   410,   362,   363,
     365,   369,   372,   376,   378,   380,   382,   384,   385,   386,
     387,   388,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   441,   443,   480,   481,   518,
     519,   520,   521,   522,   523,   454,   457,   458,   459,   462,
     463,   464,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   470,   473,   474,
     475,   478,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,     0,     0,     0,
       0,     0,     0,     0,   479,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   125
  };

  /* YYCHECK.  */
  const short int
  conf_parser::yycheck_[] =
  {
         4,     4,     4,    18,     4,     4,     4,     4,     4,     4,
      16,    17,    67,    75,    76,    77,    78,    15,    10,    69,
      70,    71,    72,    73,     9,    10,    11,    25,    26,    27,
      28,    29,    30,    88,     9,    10,     0,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    55,    56,   124,    51,
      14,   127,    54,     9,    10,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,     3,   124,    31,    32,   127,
      52,    53,    74,    80,    81,    82,    83,    79,    42,     9,
      10,    11,    84,    85,     4,   126,    50,    89,    67,    68,
      92,    12,    13,    95,    93,    94,     3,   100,    90,    91,
       9,    10,    11,   106,   107,   108,   106,   107,   111,   109,
     125,   111,   109,   127,   111,   110,    86,    87,     3,   122,
     123,     3,   122,   123,   128,   122,   123,   122,   123,   117,
     118,    51,   125,   124,    54,     3,   125,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,     4,    19,    20,
      21,    22,    23,    24,    74,    96,    97,    98,    99,    79,
     117,   118,   117,   118,    84,    85,   120,   121,   128,    89,
       3,   124,    92,   124,   124,    95,    69,    70,    71,    72,
      73,   112,   113,   114,   115,   116,    43,    44,    45,    46,
      47,    48,    49,   101,   102,   103,   104,   105,   112,   113,
     114,   115,   116,   125,   127,     7,   125,   124,     7,   125,
     125,     7,   125,   125,   125,   125,     7,     7,     7,   125,
     124,   124,   127,   125,   124,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,   124,    67,
     124,   124,     3,   124,   124,     7,   125,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     125,   125,   125,   125,   125,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,   127,   125,   125,
     125,   125,     7,     7,   125,   127,   125,     7,   125,   125,
     125,   125,   125,     7,     7,     7,     7,     7,     7,     7,
       3,     3,     3,     3,   126,   126,   125,   125,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,   124,   124,   124,   124,   124,
     124,   124,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,   124,   124,   124,
     124,   124,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned short int
  conf_parser::yystos_[] =
  {
         0,   134,     0,    14,    31,    32,    42,    50,   135,   136,
     155,   160,   174,   191,     3,   126,   161,     3,   127,   137,
     156,     3,   175,   124,   192,     4,    15,    25,    26,    27,
      28,    29,    30,   138,     3,   162,     4,    43,    44,    45,
      46,    47,    48,    49,   176,   193,     3,    16,    17,    19,
      20,    21,    22,    23,    24,    18,   125,   125,   125,   124,
     124,   157,     4,    33,    34,    35,    36,    37,    38,    39,
      40,    41,   163,   128,   185,   187,   125,   189,   125,   124,
       3,   194,   124,   127,   124,   127,   145,   146,   147,   148,
     149,   150,   143,   144,   152,   151,   154,   153,     4,   128,
     158,   124,   125,   125,     9,    10,   125,   125,   125,   125,
     125,   124,   177,   127,   179,   186,   127,   180,   188,   181,
     125,   182,   190,   183,   184,   194,     4,    51,    54,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    74,
      79,    84,    85,    89,    92,    95,   195,   139,   124,   141,
     124,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,   159,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   178,     7,     7,     7,     7,     7,
       7,     7,     4,    52,    53,    55,    56,     9,    10,    11,
     124,     9,    10,    11,   124,   124,     9,    10,    11,   124,
       9,    10,   124,    67,    68,    75,    76,    77,    78,    80,
      81,    82,    83,    67,    88,    67,    10,    90,    91,     3,
      96,    97,    98,    99,     7,   140,     7,   142,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     196,   197,   198,   199,   200,   201,    12,    13,   202,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    69,    70,    71,    72,    73,    69,    70,    71,
      72,    73,   125,   125,   125,   125,   239,   240,   241,   242,
     125,   243,   125,   245,    86,    87,   247,   250,   252,   251,
     257,   253,   254,   255,   256,     7,     7,     7,     7,     7,
       7,     7,     7,   203,   204,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,   127,
     218,   125,   125,   125,   223,   125,   127,   225,   125,   125,
     125,   230,   125,   232,   125,   233,   125,   235,   125,   237,
       7,     7,     7,     7,   244,     7,   246,     7,   248,   249,
       7,     7,     7,     7,     4,    93,    94,   258,     3,     3,
       3,     3,     7,     7,   219,     7,   220,   221,   224,     7,
     222,   226,     7,   227,   228,   231,     7,   229,     7,   234,
       7,   236,     7,   238,     7,     7,     7,     7,     7,   126,
     126,   263,   281,   288,   301,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,   125,   259,
     125,   261,     4,   100,   106,   107,   108,   111,   122,   123,
     264,     4,   109,   111,   122,   123,   282,     4,   106,   107,
     109,   111,   122,   123,   289,     4,   110,   122,   123,   302,
     260,     7,   262,     7,   101,   102,   103,   104,   105,   112,
     113,   114,   115,   116,   124,   117,   118,   124,   124,   124,
     117,   118,   124,   124,   124,   112,   113,   114,   115,   116,
     124,   117,   118,   124,   124,   124,   120,   121,   124,   124,
       7,     7,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   283,   284,
     285,   286,   287,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   303,   304,   305,   306,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  conf_parser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned short int
  conf_parser::yyr1_[] =
  {
         0,   133,   134,   134,   135,   135,   135,   135,   135,   136,
     137,   137,   139,   138,   140,   138,   141,   138,   142,   138,
     143,   138,   144,   138,   145,   138,   146,   138,   147,   138,
     148,   138,   149,   138,   150,   138,   151,   138,   152,   138,
     153,   138,   154,   138,   156,   155,   157,   157,   159,   158,
     161,   160,   162,   162,   164,   163,   165,   163,   166,   163,
     167,   163,   168,   163,   169,   163,   170,   163,   171,   163,
     172,   163,   173,   163,   174,   175,   175,   177,   176,   178,
     176,   179,   176,   180,   176,   181,   176,   182,   176,   183,
     176,   184,   176,   185,   185,   186,   187,   187,   188,   189,
     189,   190,   192,   191,   193,   191,   194,   194,   196,   195,
     197,   195,   198,   195,   199,   195,   200,   195,   201,   195,
     202,   195,   203,   195,   204,   195,   205,   195,   206,   195,
     207,   195,   208,   195,   209,   195,   210,   195,   211,   195,
     212,   195,   213,   195,   214,   195,   215,   195,   216,   195,
     217,   195,   218,   195,   219,   195,   220,   195,   221,   195,
     222,   195,   223,   195,   224,   195,   225,   195,   226,   195,
     227,   195,   228,   195,   229,   195,   230,   195,   231,   195,
     232,   195,   233,   195,   234,   195,   235,   195,   236,   195,
     237,   195,   238,   195,   239,   195,   240,   195,   241,   195,
     242,   195,   243,   195,   244,   195,   245,   195,   246,   195,
     247,   195,   248,   195,   249,   195,   250,   195,   251,   195,
     252,   195,   195,   253,   195,   254,   195,   255,   195,   256,
     195,   257,   257,   259,   258,   260,   258,   261,   258,   262,
     258,   263,   263,   265,   264,   266,   264,   267,   264,   268,
     264,   269,   264,   270,   264,   271,   264,   272,   264,   273,
     264,   274,   264,   275,   264,   276,   264,   277,   264,   278,
     264,   279,   264,   280,   264,   281,   281,   283,   282,   284,
     282,   285,   282,   286,   282,   287,   282,   288,   288,   290,
     289,   291,   289,   292,   289,   293,   289,   294,   289,   295,
     289,   296,   289,   297,   289,   298,   289,   299,   289,   300,
     289,   301,   301,   303,   302,   304,   302,   305,   302,   306,
     302
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  conf_parser::yyr2_[] =
  {
         0,     2,     0,     2,     1,     1,     1,     1,     1,     4,
       0,     2,     0,     5,     0,     6,     0,     5,     0,     6,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     6,     0,     2,     0,     3,
       0,     5,     0,     2,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     4,     0,     2,     0,     4,     0,
       5,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     2,     1,     0,     2,     1,     0,
       2,     1,     0,     6,     0,     7,     0,     2,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     5,     0,     5,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     5,     0,     6,     0,     6,     0,     6,
       0,     6,     0,     5,     0,     6,     0,     5,     0,     6,
       0,     6,     0,     6,     0,     6,     0,     5,     0,     6,
       0,     5,     0,     5,     0,     6,     0,     5,     0,     6,
       0,     5,     0,     6,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     5,     0,     4,     0,     5,
       0,     4,     0,     5,     0,     5,     0,     4,     0,     4,
       0,     4,     4,     0,     6,     0,     6,     0,     6,     0,
       6,     0,     2,     0,     4,     0,     5,     0,     4,     0,
       5,     0,     2,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     2,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     2,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     2,     0,     4,     0,     4,     0,     4,     0,
       4
  };

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const conf_parser::yytname_[] =
  {
    "\"end of file\"", "error", "$undefined", "\"begin section\"",
  "\"end section\"", "\"begin grouping\"", "\"end grouping\"",
  "\"end of statement\"", "\"sequence\"", "\"enable\"", "\"disable\"",
  "\"force\"", "\"draft\"", "\"rfc\"", "\"deamon section\"", "\"socket\"",
  "\"ike\"", "\"natt\"", "\"syslog\"", "\"none\"", "\"error\"", "\"info\"",
  "\"debug\"", "\"loud\"", "\"decode\"", "\"log level\"", "\"log file\"",
  "\"decrypted ike pcap dump file\"", "\"encrypted ike pcap dump file\"",
  "\"retry count\"", "\"retry delay\"", "\"netgroup section\"",
  "\"xauth ldap section\"", "\"version\"", "\"url\"", "\"base\"",
  "\"subtree\"", "\"bind dn\"", "\"bind pw\"", "\"user attribute\"",
  "\"group attribute\"", "\"member attribute\"",
  "\"xconfig local section\"", "\"network4\"", "\"domain name server\"",
  "\"nerbios name server\"", "\"dns suffix\"", "\"dns list\"",
  "\"banner\"", "\"pfs group\"", "\"peer section\"", "\"contact type\"",
  "\"initiator\"", "\"responder\"", "\"exchange type\"", "\"main\"",
  "\"aggressive\"", "\"natt mode\"", "\"natt keepalive rate\"",
  "\"dpd mode\"", "\"dpd notifiy delay\"", "\"dpd notifiy retries\"",
  "\"frag ike mode\"", "\"frag ike size\"", "\"frag esp mode\"",
  "\"frag esp size\"", "\"peer id\"", "\"local\"", "\"remote\"",
  "\"address\"", "\"fqdn\"", "\"ufqdn\"", "\"asn1dn\"", "\"keyid\"",
  "\"authdata\"", "\"psk\"", "\"ca\"", "\"cert\"", "\"pkey\"",
  "\"lifetime check\"", "\"obey\"", "\"claim\"", "\"strict\"", "\"exact\"",
  "\"xauth source\"", "\"xconf source\"", "\"pull\"", "\"push\"",
  "\"ldap\"", "\"policy mode\"", "\"config\"", "\"compat\"",
  "\"policy list section\"", "\"include\"", "\"exclude\"",
  "\"proposal section\"", "\"isakmp\"", "\"ah\"", "\"esp\"", "\"ipcomp\"",
  "\"auth\"", "\"hybrid xauth rsa\"", "\"mutual xauth rsa\"",
  "\"mutual xauth psk\"", "\"mutual rsa\"", "\"mutual psk\"", "\"cipher\"",
  "\"klen\"", "\"hash\"", "\"hmac\"", "\"compress\"", "\"dh group\"",
  "\"aes\"", "\"blowfish\"", "\"3des\"", "\"cast\"", "\"des\"", "\"md5\"",
  "\"sha1\"", "\"dhgr\"", "\"deflate\"", "\"lzs\"", "\"life sec\"",
  "\"life kbs\"", "\"number value\"", "\"quoted value\"",
  "\"label value\"", "\"address value\"", "\"network value\"",
  "\"number\"", "\"quoted\"", "\"label\"", "\"network\"", "$accept",
  "sections", "section", "daemon_section", "daemon_lines", "daemon_line",
  "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10",
  "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "netgroup_section",
  "$@17", "netgroup_lines", "netgroup_line", "$@18", "xauth_ldap_section",
  "$@19", "xauth_ldap_lines", "xauth_ldap_line", "$@20", "$@21", "$@22",
  "$@23", "$@24", "$@25", "$@26", "$@27", "$@28", "$@29",
  "xconf_local_section", "xconf_local_lines", "xconf_local_line", "$@30",
  "$@31", "$@32", "$@33", "$@34", "$@35", "$@36", "$@37",
  "xconf_local_dns_servers", "xconf_local_dns_server",
  "xconf_local_nbn_servers", "xconf_local_nbn_server",
  "xconf_local_dns_names", "xconf_local_dns_name", "peer_section", "$@38",
  "$@39", "peer_lines", "peer_line", "$@40", "$@41", "$@42", "$@43",
  "$@44", "$@45", "$@46", "$@47", "$@48", "$@49", "$@50", "$@51", "$@52",
  "$@53", "$@54", "$@55", "$@56", "$@57", "$@58", "$@59", "$@60", "$@61",
  "$@62", "$@63", "$@64", "$@65", "$@66", "$@67", "$@68", "$@69", "$@70",
  "$@71", "$@72", "$@73", "$@74", "$@75", "$@76", "$@77", "$@78", "$@79",
  "$@80", "$@81", "$@82", "$@83", "$@84", "$@85", "$@86", "$@87", "$@88",
  "$@89", "$@90", "$@91", "$@92", "$@93", "$@94", "$@95", "$@96", "$@97",
  "$@98", "$@99", "$@100", "plcy_list_lines", "plcy_list_line", "$@101",
  "$@102", "$@103", "$@104", "proposal_lines_isakmp",
  "proposal_line_isakmp", "$@105", "$@106", "$@107", "$@108", "$@109",
  "$@110", "$@111", "$@112", "$@113", "$@114", "$@115", "$@116", "$@117",
  "$@118", "$@119", "$@120", "proposal_lines_ah", "proposal_line_ah",
  "$@121", "$@122", "$@123", "$@124", "$@125", "proposal_lines_esp",
  "proposal_line_esp", "$@126", "$@127", "$@128", "$@129", "$@130",
  "$@131", "$@132", "$@133", "$@134", "$@135", "$@136",
  "proposal_lines_ipcomp", "proposal_line_ipcomp", "$@137", "$@138",
  "$@139", "$@140", 0
  };
#endif

#if YYDEBUG
  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const conf_parser::rhs_number_type
  conf_parser::yyrhs_[] =
  {
       134,     0,    -1,    -1,   134,   135,    -1,   136,    -1,   155,
      -1,   160,    -1,   174,    -1,   191,    -1,    14,     3,   137,
       4,    -1,    -1,   137,   138,    -1,    -1,    15,    16,   124,
     139,     7,    -1,    -1,    15,    16,   127,   124,   140,     7,
      -1,    -1,    15,    17,   124,   141,     7,    -1,    -1,    15,
      17,   127,   124,   142,     7,    -1,    -1,    26,    18,   143,
       7,    -1,    -1,    26,   125,   144,     7,    -1,    -1,    25,
      19,   145,     7,    -1,    -1,    25,    20,   146,     7,    -1,
      -1,    25,    21,   147,     7,    -1,    -1,    25,    22,   148,
       7,    -1,    -1,    25,    23,   149,     7,    -1,    -1,    25,
      24,   150,     7,    -1,    -1,    28,   125,   151,     7,    -1,
      -1,    27,   125,   152,     7,    -1,    -1,    30,   124,   153,
       7,    -1,    -1,    29,   124,   154,     7,    -1,    -1,    31,
     126,   156,     3,   157,     4,    -1,    -1,   157,   158,    -1,
      -1,   128,   159,     7,    -1,    -1,    32,   161,     3,   162,
       4,    -1,    -1,   162,   163,    -1,    -1,    33,   124,   164,
       7,    -1,    -1,    34,   125,   165,     7,    -1,    -1,    35,
     125,   166,     7,    -1,    -1,    36,     9,   167,     7,    -1,
      -1,    36,    10,   168,     7,    -1,    -1,    37,   125,   169,
       7,    -1,    -1,    38,   125,   170,     7,    -1,    -1,    39,
     125,   171,     7,    -1,    -1,    40,   125,   172,     7,    -1,
      -1,    41,   125,   173,     7,    -1,    42,     3,   175,     4,
      -1,    -1,   175,   176,    -1,    -1,    43,   128,   177,     7,
      -1,    -1,    43,   128,   124,   178,     7,    -1,    -1,    44,
     185,   179,     7,    -1,    -1,    45,   187,   180,     7,    -1,
      -1,    46,   125,   181,     7,    -1,    -1,    47,   189,   182,
       7,    -1,    -1,    48,   125,   183,     7,    -1,    -1,    49,
     124,   184,     7,    -1,    -1,   185,   186,    -1,   127,    -1,
      -1,   187,   188,    -1,   127,    -1,    -1,   189,   190,    -1,
     125,    -1,    -1,    50,   127,   192,     3,   194,     4,    -1,
      -1,    50,   127,   124,   193,     3,   194,     4,    -1,    -1,
     194,   195,    -1,    -1,    51,    52,   196,     7,    -1,    -1,
      51,    53,   197,     7,    -1,    -1,    54,    55,   198,     7,
      -1,    -1,    54,    56,   199,     7,    -1,    -1,    57,     9,
     200,     7,    -1,    -1,    57,    10,   201,     7,    -1,    -1,
      57,    11,   202,     7,    -1,    -1,    57,    11,    12,   203,
       7,    -1,    -1,    57,    11,    13,   204,     7,    -1,    -1,
      58,   124,   205,     7,    -1,    -1,    59,     9,   206,     7,
      -1,    -1,    59,    10,   207,     7,    -1,    -1,    59,    11,
     208,     7,    -1,    -1,    60,   124,   209,     7,    -1,    -1,
      61,   124,   210,     7,    -1,    -1,    62,     9,   211,     7,
      -1,    -1,    62,    10,   212,     7,    -1,    -1,    62,    11,
     213,     7,    -1,    -1,    63,   124,   214,     7,    -1,    -1,
      64,     9,   215,     7,    -1,    -1,    64,    10,   216,     7,
      -1,    -1,    65,   124,   217,     7,    -1,    -1,    66,    67,
      69,   218,     7,    -1,    -1,    66,    67,    69,   127,   219,
       7,    -1,    -1,    66,    67,    70,   125,   220,     7,    -1,
      -1,    66,    67,    71,   125,   221,     7,    -1,    -1,    66,
      67,    73,   125,   222,     7,    -1,    -1,    66,    67,    72,
     223,     7,    -1,    -1,    66,    67,    72,   125,   224,     7,
      -1,    -1,    66,    68,    69,   225,     7,    -1,    -1,    66,
      68,    69,   127,   226,     7,    -1,    -1,    66,    68,    70,
     125,   227,     7,    -1,    -1,    66,    68,    71,   125,   228,
       7,    -1,    -1,    66,    68,    73,   125,   229,     7,    -1,
      -1,    66,    68,    72,   230,     7,    -1,    -1,    66,    68,
      72,   125,   231,     7,    -1,    -1,    74,    75,   125,   232,
       7,    -1,    -1,    74,    76,   125,   233,     7,    -1,    -1,
      74,    76,   125,   125,   234,     7,    -1,    -1,    74,    77,
     125,   235,     7,    -1,    -1,    74,    77,   125,   125,   236,
       7,    -1,    -1,    74,    78,   125,   237,     7,    -1,    -1,
      74,    78,   125,   125,   238,     7,    -1,    -1,    79,    80,
     239,     7,    -1,    -1,    79,    81,   240,     7,    -1,    -1,
      79,    82,   241,     7,    -1,    -1,    79,    83,   242,     7,
      -1,    -1,    84,    67,   243,     7,    -1,    -1,    84,    67,
     125,   244,     7,    -1,    -1,    84,    88,   245,     7,    -1,
      -1,    84,    88,   125,   246,     7,    -1,    -1,    85,    67,
     247,     7,    -1,    -1,    85,    67,    86,   248,     7,    -1,
      -1,    85,    67,    87,   249,     7,    -1,    -1,    89,    10,
     250,     7,    -1,    -1,    89,    91,   251,     7,    -1,    -1,
      89,    90,   252,     7,    -1,    92,     3,   257,     4,    -1,
      -1,    95,    96,   253,     3,   263,     4,    -1,    -1,    95,
      97,   254,     3,   281,     4,    -1,    -1,    95,    98,   255,
       3,   288,     4,    -1,    -1,    95,    99,   256,     3,   301,
       4,    -1,    -1,   257,   258,    -1,    -1,    93,   126,   259,
       7,    -1,    -1,    93,   126,   125,   260,     7,    -1,    -1,
      94,   126,   261,     7,    -1,    -1,    94,   126,   125,   262,
       7,    -1,    -1,   263,   264,    -1,    -1,   100,   101,   265,
       7,    -1,    -1,   100,   102,   266,     7,    -1,    -1,   100,
     103,   267,     7,    -1,    -1,   100,   104,   268,     7,    -1,
      -1,   100,   105,   269,     7,    -1,    -1,   106,   112,   270,
       7,    -1,    -1,   106,   113,   271,     7,    -1,    -1,   106,
     114,   272,     7,    -1,    -1,   106,   115,   273,     7,    -1,
      -1,   106,   116,   274,     7,    -1,    -1,   107,   124,   275,
       7,    -1,    -1,   108,   117,   276,     7,    -1,    -1,   108,
     118,   277,     7,    -1,    -1,   111,   124,   278,     7,    -1,
      -1,   122,   124,   279,     7,    -1,    -1,   123,   124,   280,
       7,    -1,    -1,   281,   282,    -1,    -1,   109,   117,   283,
       7,    -1,    -1,   109,   118,   284,     7,    -1,    -1,   111,
     124,   285,     7,    -1,    -1,   122,   124,   286,     7,    -1,
      -1,   123,   124,   287,     7,    -1,    -1,   288,   289,    -1,
      -1,   106,   112,   290,     7,    -1,    -1,   106,   113,   291,
       7,    -1,    -1,   106,   114,   292,     7,    -1,    -1,   106,
     115,   293,     7,    -1,    -1,   106,   116,   294,     7,    -1,
      -1,   107,   124,   295,     7,    -1,    -1,   109,   117,   296,
       7,    -1,    -1,   109,   118,   297,     7,    -1,    -1,   111,
     124,   298,     7,    -1,    -1,   122,   124,   299,     7,    -1,
      -1,   123,   124,   300,     7,    -1,    -1,   301,   302,    -1,
      -1,   110,   120,   303,     7,    -1,    -1,   110,   121,   304,
       7,    -1,    -1,   122,   124,   305,     7,    -1,    -1,   123,
     124,   306,     7,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned short int
  conf_parser::yyprhs_[] =
  {
         0,     0,     3,     4,     7,     9,    11,    13,    15,    17,
      22,    23,    26,    27,    33,    34,    41,    42,    48,    49,
      56,    57,    62,    63,    68,    69,    74,    75,    80,    81,
      86,    87,    92,    93,    98,    99,   104,   105,   110,   111,
     116,   117,   122,   123,   128,   129,   136,   137,   140,   141,
     145,   146,   152,   153,   156,   157,   162,   163,   168,   169,
     174,   175,   180,   181,   186,   187,   192,   193,   198,   199,
     204,   205,   210,   211,   216,   221,   222,   225,   226,   231,
     232,   238,   239,   244,   245,   250,   251,   256,   257,   262,
     263,   268,   269,   274,   275,   278,   280,   281,   284,   286,
     287,   290,   292,   293,   300,   301,   309,   310,   313,   314,
     319,   320,   325,   326,   331,   332,   337,   338,   343,   344,
     349,   350,   355,   356,   362,   363,   369,   370,   375,   376,
     381,   382,   387,   388,   393,   394,   399,   400,   405,   406,
     411,   412,   417,   418,   423,   424,   429,   430,   435,   436,
     441,   442,   447,   448,   454,   455,   462,   463,   470,   471,
     478,   479,   486,   487,   493,   494,   501,   502,   508,   509,
     516,   517,   524,   525,   532,   533,   540,   541,   547,   548,
     555,   556,   562,   563,   569,   570,   577,   578,   584,   585,
     592,   593,   599,   600,   607,   608,   613,   614,   619,   620,
     625,   626,   631,   632,   637,   638,   644,   645,   650,   651,
     657,   658,   663,   664,   670,   671,   677,   678,   683,   684,
     689,   690,   695,   700,   701,   708,   709,   716,   717,   724,
     725,   732,   733,   736,   737,   742,   743,   749,   750,   755,
     756,   762,   763,   766,   767,   772,   773,   778,   779,   784,
     785,   790,   791,   796,   797,   802,   803,   808,   809,   814,
     815,   820,   821,   826,   827,   832,   833,   838,   839,   844,
     845,   850,   851,   856,   857,   862,   863,   866,   867,   872,
     873,   878,   879,   884,   885,   890,   891,   896,   897,   900,
     901,   906,   907,   912,   913,   918,   919,   924,   925,   930,
     931,   936,   937,   942,   943,   948,   949,   954,   955,   960,
     961,   966,   967,   970,   971,   976,   977,   982,   983,   988,
     989
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned short int
  conf_parser::yyrline_[] =
  {
         0,   239,   239,   241,   244,   245,   246,   247,   248,   257,
     259,   261,   265,   264,   277,   276,   292,   291,   308,   307,
     327,   326,   333,   332,   339,   338,   344,   343,   349,   348,
     354,   353,   359,   358,   364,   363,   369,   368,   376,   375,
     383,   382,   388,   387,   401,   400,   412,   414,   418,   417,
     450,   449,   457,   459,   463,   462,   473,   472,   481,   480,
     489,   488,   496,   495,   503,   502,   511,   510,   519,   518,
     527,   526,   535,   534,   550,   552,   554,   558,   557,   573,
     572,   588,   587,   593,   592,   598,   597,   611,   610,   616,
     615,   631,   630,   638,   640,   643,   656,   658,   661,   674,
     676,   679,   694,   693,   729,   728,   764,   766,   770,   769,
     775,   774,   780,   779,   785,   784,   790,   789,   799,   798,
     808,   807,   817,   816,   826,   825,   835,   834,   844,   843,
     849,   848,   854,   853,   859,   858,   864,   863,   869,   868,
     874,   873,   879,   878,   884,   883,   889,   888,   894,   893,
     899,   898,   904,   903,   909,   908,   916,   915,   923,   922,
     930,   929,   937,   936,   942,   941,   949,   948,   954,   953,
     961,   960,   968,   967,   975,   974,   982,   981,   987,   986,
     994,   993,  1000,   999,  1013,  1012,  1028,  1027,  1042,  1041,
    1057,  1056,  1070,  1069,  1084,  1083,  1089,  1088,  1094,  1093,
    1099,  1098,  1104,  1103,  1109,  1108,  1116,  1115,  1128,  1127,
    1142,  1141,  1148,  1147,  1154,  1153,  1160,  1159,  1165,  1164,
    1170,  1169,  1174,  1176,  1175,  1187,  1186,  1196,  1195,  1205,
    1204,  1215,  1217,  1221,  1220,  1242,  1241,  1264,  1263,  1285,
    1284,  1308,  1310,  1314,  1313,  1319,  1318,  1324,  1323,  1329,
    1328,  1334,  1333,  1339,  1338,  1344,  1343,  1349,  1348,  1354,
    1353,  1359,  1358,  1364,  1363,  1369,  1368,  1374,  1373,  1379,
    1378,  1413,  1412,  1418,  1417,  1424,  1426,  1430,  1429,  1436,
    1435,  1442,  1441,  1476,  1475,  1481,  1480,  1487,  1489,  1493,
    1492,  1498,  1497,  1503,  1502,  1508,  1507,  1513,  1512,  1518,
    1517,  1523,  1522,  1528,  1527,  1533,  1532,  1567,  1566,  1572,
    1571,  1578,  1580,  1584,  1583,  1589,  1588,  1594,  1593,  1599,
    1598
  };

  // Print the state stack on the debug stream.
  void
  conf_parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  conf_parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "):" << std::endl;
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
		       yyrhs_[yyprhs_[yyrule] + yyi],
		       &(yysemantic_stack_[(yynrhs) - (yyi + 1)]),
		       &(yylocation_stack_[(yynrhs) - (yyi + 1)]));
  }
#endif // YYDEBUG

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  conf_parser::token_number_type
  conf_parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int conf_parser::yyeof_ = 0;
  const int conf_parser::yylast_ = 428;
  const int conf_parser::yynnts_ = 174;
  const int conf_parser::yyempty_ = -2;
  const int conf_parser::yyfinal_ = 2;
  const int conf_parser::yyterror_ = 1;
  const int conf_parser::yyerrcode_ = 256;
  const int conf_parser::yyntokens_ = 133;

  const unsigned int conf_parser::yyuser_token_number_max_ = 387;
  const conf_parser::token_number_type conf_parser::yyundef_token_ = 2;


} // yy

/* Line 1053 of lalr1.cc  */
#line 3302 "conf.parse.cpp"


/* Line 1055 of lalr1.cc  */
#line 1605 "/home/mandrake/rpm/BUILD/ike/source/iked/conf.parse.yy"


void yy::conf_parser::error(
	const yy::conf_parser::location_type & l,
        const std::string & m )
{
	iked.log.txt( LLOG_ERROR,
		"%s ( line %i, col %i )\n",
		m.c_str(),
		l.end.line,
		l.end.column );

	exit( -1 );

	iked.conf_fail = true;
}

